'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var through2 = require('through2').obj;
var filesize = require('filesize');

var CheckDiffSize = function () {
	function CheckDiffSize() {
		_classCallCheck(this, CheckDiffSize);

		this.allSrcSize = 0;
		this.allDestSize = 0;
		this.propSize = '__origSize_' + Math.random().toString(36).slice(2) + '__';
	}

	_createClass(CheckDiffSize, [{
		key: 'saveOrigSize',
		value: function saveOrigSize(file) {
			file[this.propSize] = this.getFileSize(file);
		}
	}, {
		key: 'getOrigSize',
		value: function getOrigSize(file) {
			return file[this.propSize] != null ? file[this.propSize] : 0;
		}
	}, {
		key: 'getFileSize',
		value: function getFileSize(file) {
			return file.contents.length;
		}
	}, {
		key: 'updateAllSrc',
		value: function updateAllSrc(file) {
			this.allSrcSize += this.getFileSize(file);
		}
	}, {
		key: 'updateAllDest',
		value: function updateAllDest(file) {
			this.allDestSize += this.getFileSize(file);
		}
	}, {
		key: 'checkSrc',
		value: function checkSrc() {
			var _this = this;

			return through2(function (file, enc, cb) {
				_this.updateAllSrc(file);
				_this.saveOrigSize(file);

				return cb(null, file);
			});
		}
	}, {
		key: 'diffSrcAndDest',
		value: function diffSrcAndDest(currentSize, originalSize) {
			if (typeof originalSize !== "number") {
				originalSize = currentSize[this.propSize];
				currentSize = this.getFileSize(currentSize);
			}

			return (100 - currentSize / originalSize * 100).toFixed(1);
		}
	}, {
		key: 'fromatSize',
		value: function fromatSize(len) {
			return filesize(len);
		}
	}, {
		key: 'getResulStr',
		value: function getResulStr(file) {
			return this.fromatSize(this.getOrigSize(file)) + ' => ' + this.fromatSize(this.getFileSize(file));
		}
	}, {
		key: 'writeDiff',
		value: function writeDiff(base_path) {
			var _this2 = this;

			return through2(function (file, enc, cb) {
				var filename = file.path.replace(base_path, '');

				_this2.updateAllDest(file);

				console.log('(' + _this2.diffSrcAndDest(file) + '%) | ' + filename + ' | ' + _this2.getResulStr(file));

				return cb(null, file);
			});
		}
	}, {
		key: 'onFinish',
		value: function onFinish() {
			var _this3 = this;

			return function () {
				console.log('All result: ' + _this3.fromatSize(_this3.allSrcSize) + ' => ' + _this3.fromatSize(_this3.allDestSize) + ' (' + _this3.diffSrcAndDest(_this3.allDestSize, _this3.allSrcSize) + '%)');
			};
		}
	}]);

	return CheckDiffSize;
}();

module.exports = CheckDiffSize;